diff -pru mailman-cvs-2.1-maint/Mailman/SecurityManager.py mailman-2.1.7.cg/Mailman/SecurityManager.py
--- mailman-cvs-2.1-maint/Mailman/SecurityManager.py	2005-08-27 03:40:15.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/SecurityManager.py	2006-03-04 12:27:50.000000000 +0100
@@ -86,6 +86,9 @@ class SecurityManager:
         # Non configurable
         self.passwords = {}
 
+    def _cookie_key(self):
+        return self.internal_name().replace('@','%40')
+
     def AuthContextInfo(self, authcontext, user=None):
         # authcontext may be one of AuthUser, AuthListModerator,
         # AuthListAdmin, AuthSiteAdmin.  Not supported is the AuthCreator
@@ -98,7 +101,8 @@ class SecurityManager:
         # AuthUser, but the user isn't a member of this mailing list, a
         # NotAMemberError will be raised.  If the user's secret is None, raise
         # a MMBadUserError.
-        key = self.internal_name() + '+'
+        # NDIM: XXX Does this have security implications?
+        key = self._cookie_key() + '+' 
         if authcontext == mm_cfg.AuthUser:
             if user is None:
                 # A bad system error
@@ -292,7 +296,7 @@ class SecurityManager:
                 usernames = [user]
             else:
                 usernames = []
-                prefix = self.internal_name() + '+user+'
+                prefix = self._cookie_key() + '+user+'
                 for k in c.keys():
                     if k.startswith(prefix):
                         usernames.append(k[len(prefix):])
diff -pru mailman-cvs-2.1-maint/Mailman/Site.py mailman-2.1.7.cg/Mailman/Site.py
--- mailman-cvs-2.1-maint/Mailman/Site.py	2005-08-27 03:40:15.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Site.py	2006-03-09 22:45:32.000000000 +0100
@@ -22,6 +22,7 @@ implementation should work for standard 
 
 import os
 import errno
+import sys
 
 from Mailman import mm_cfg
 
@@ -47,35 +48,57 @@ def _makedir(path):
 
 
 
-# BAW: We don't really support domain<>None yet.  This will be added in a
-# future version.  By default, Mailman will never pass in a domain argument.
-def get_listpath(listname, domain=None, create=0):
-    """Return the file system path to the list directory for the named list.
+def get_listsubdir(listname):
+    """Return subdirectory name for the named list.
 
-    If domain is given, it is the virtual domain for the named list.  The
-    default is to not distinguish list paths on the basis of virtual domains.
+    Append this subdirectory name to a subsystem specific directory
+    such as archives/private/ or similar.
+
+    The directory scheme implemented is like this:
+    
+        <subsystem directory>/
+           mylist0/            # one "site default list"
+           mylist1/            # another "site default list"
+           some.domain.com/
+              mylist1/         # a "vhost list"
+              mylist2/         # another "vhost list"
+           mydomain.com/
+              mylist1/         # yet another "vhost list"
+
+    Ideally, this function and get_listnames() below would be the only
+    code to modify if you want to introduce another disk storage
+    scheme, e.g. d/domain.com/mylist1 and m/mydomain.com/mylist1.
+    
+    See also get_listpath and get_archpath docs for example usage.
+    """
+    if '@' in listname:
+        tmp = listname.split('@')
+        return os.path.join(tmp[1],tmp[0])
+    else:
+        return listname
+    
+    
+
+def get_listpath(listname, create=0):
+    """Return the file system path to the list directory for the named list.
 
     If the create flag is true, then this method should create the path
     hierarchy if necessary.  If the create flag is false, then this function
     should not attempt to create the path heirarchy (and in fact the absence
     of the path might be significant).
     """
-    path = os.path.join(mm_cfg.LIST_DATA_DIR, listname)
+    path = os.path.join(mm_cfg.LIST_DATA_DIR,
+                        get_listsubdir(listname))
     if create:
         _makedir(path)
     return path
 
 
 
-# BAW: We don't really support domain<>None yet.  This will be added in a
-# future version.  By default, Mailman will never pass in a domain argument.
-def get_archpath(listname, domain=None, create=False, public=False):
+def get_archpath(listname, create=False, public=False):
     """Return the file system path to the list's archive directory for the
     named list in the named virtual domain.
 
-    If domain is given, it is the virtual domain for the named list.  The
-    default is to not distinguish list paths on the basis of virtual domains.
-
     If the create flag is true, then this method should create the path
     hierarchy if necessary.  If the create flag is false, then this function
     should not attempt to create the path heirarchy (and in fact the absence
@@ -88,15 +111,20 @@ def get_archpath(listname, domain=None, 
         subdir = mm_cfg.PUBLIC_ARCHIVE_FILE_DIR
     else:
         subdir = mm_cfg.PRIVATE_ARCHIVE_FILE_DIR
-    path = os.path.join(subdir, listname)
+    path = os.path.join(subdir, get_listsubdir(listname))
     if create:
         _makedir(path)
     return path
 
 
 
-# BAW: We don't really support domain<>None yet.  This will be added in a
-# future version.  By default, Mailman will never pass in a domain argument.
+def get_mboxpath(listname, create=False, public=False):
+    """Get path to archive mbox file"""
+    return os.path.join(get_archpath(listname) + '.mbox',
+                        listname.split('@')[0] + '.mbox')
+
+
+
 def get_listnames(domain=None):
     """Return the names of all the known lists for the given domain.
 
@@ -105,9 +133,19 @@ def get_listnames(domain=None):
     """
     # Import this here to avoid circular imports
     from Mailman.Utils import list_exists
-    # We don't currently support separate virtual domain directories
     got = []
-    for fn in os.listdir(mm_cfg.LIST_DATA_DIR):
-        if list_exists(fn):
-            got.append(fn)
+    datadir = mm_cfg.LIST_DATA_DIR
+    if domain:
+        domaindir = os.path.join(datadir, domain)
+        if os.path.isdir(domaindir):
+            for localpart in os.listdir(domaindir):
+                listname = '@'.join([localpart, domain])
+                if list_exists(listname):
+                    got.append(listname)
+    else:
+        for fn in os.listdir(datadir):
+            if list_exists(fn):
+                got.append(fn)
+            else:
+                got.extend(get_listnames(fn))
     return got
diff -pru mailman-cvs-2.1-maint/Mailman/Utils.py mailman-2.1.7.cg/Mailman/Utils.py
--- mailman-cvs-2.1-maint/Mailman/Utils.py	2005-08-27 03:40:15.000000000 +0200
+++ mailman-2.1.7.cg/Mailman/Utils.py	2006-03-10 16:05:32.000000000 +0100
@@ -218,6 +218,7 @@ def ValidateEmail(s):
 
 
 
+# Helper function for CGI scripts
 def GetPathPieces(envar='PATH_INFO'):
     path = os.environ.get(envar)
     if path:
@@ -226,6 +227,39 @@ def GetPathPieces(envar='PATH_INFO'):
 
 
 
+# Helper function for CGI scripts
+def _GetURLHost(envar='SERVER_NAME'):
+    # NDIM XXX: Not pretty logic.
+    web_server_name = os.environ.get(envar)
+    if web_server_name:
+        return web_server_name.lower()
+    return mm_cfg.DEFAULT_URL_HOST
+
+
+
+# Helper function for CGI scripts
+def _GetEmailHost(url_host=None):
+    return mm_cfg.VIRTUAL_HOSTS.get(url_host or _GetURLHost(),
+                                    mm_cfg.DEFAULT_EMAIL_HOST)
+
+
+
+# Helper function for CGI scripts
+def GetListName(parts=None):
+    # NDIM XXX Not pretty either
+    if not parts:
+        parts = GetPathPieces()
+    local_part = parts[0].lower()
+    url_host = _GetURLHost()
+
+    if url_host == mm_cfg.DEFAULT_URL_HOST:
+        return local_part
+    else:
+        email_host = _GetEmailHost(url_host=url_host)
+        return '@'.join([local_part,email_host])
+
+
+
 def ScriptURL(target, web_page_url=None, absolute=False):
     """target - scriptname only, nothing extra
     web_page_url - the list's configvar of the same name
@@ -530,6 +564,19 @@ def findtext(templatefile, dict=None, ra
     fp.close()
     text = template
     if dict is not None:
+        # Fix up incorrect template usage introduced in vhost branch:
+        #   - templates use %(listname)s@%(hostname)s patterns
+        #   - pre-vhost Mailman uses { 'listname': mlist.internal_name(),
+        #                              'hostname': mlist.host_name, }
+        #   - vhost Mailman uses     { 'listname': mlist.local_part,
+        #                              'hostname': mlist.host_name, }
+        # Just to make sure, we also log this, so we can fix the code.
+        if dict.has_key('listname'):
+            if '@' in dict['listname']:
+                from Mailman.Logging.Syslog import syslog
+                syslog('vhost', 'vhost warning: listname %s is using @ for template file %s',
+                       repr(dict['listname']), repr(templatefile))
+                dict['listname'] = dict['listname'].split('@')[0]
         try:
             sdict = SafeDict(dict)
             try:
@@ -706,7 +753,7 @@ def unique_message_id(mlist):
     global _serial
     msgid = '<mailman.%d.%d.%d.%s@%s>' % (
         _serial, time.time(), os.getpid(),
-        mlist.internal_name(), mlist.host_name)
+        mlist.local_part, mlist.host_name)
     _serial += 1
     return msgid
 
diff -pru mailman-cvs-2.1-maint/Mailman/Version.py mailman-2.1.7.cg/Mailman/Version.py
--- mailman-cvs-2.1-maint/Mailman/Version.py	2006-03-10 11:36:50.000000000 +0100
+++ mailman-2.1.7.cg/Mailman/Version.py	2005-12-31 12:43:56.000000000 +0100
@@ -15,7 +15,7 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 # Mailman version
-VERSION = "2.1.8a1"
+VERSION = "2.1.7"
 
 # And as a hex number in the manner of PY_VERSION_HEX
 ALPHA = 0xa
@@ -27,8 +27,8 @@ FINAL = 0xf
 
 MAJOR_REV = 2
 MINOR_REV = 1
-MICRO_REV = 8
-REL_LEVEL = ALPHA
+MICRO_REV = 7
+REL_LEVEL = FINAL
 # at most 15 beta releases!
 REL_SERIAL = 1
 
diff -pru mailman-cvs-2.1-maint/NEWS mailman-2.1.7.cg/NEWS
--- mailman-cvs-2.1-maint/NEWS	2006-03-10 11:36:50.000000000 +0100
+++ mailman-2.1.7.cg/NEWS	2005-12-31 12:43:55.000000000 +0100
@@ -4,40 +4,6 @@ Copyright (C) 1998-2005 by the Free Soft
 
 Here is a history of user visible changes to Mailman.
 
-2.1.8a1 (10-Mar-2006)
-
-  Bug fixes and other patches
-
-    - Bouncers support added: 'unknown user', Microsoft SMTPSVC, Prodigy.net
-      and several others.
-
-    - Updated email library to 2.5.7 which will encode payload into qp/base64
-      upon setting.  This enabled backing out the scrubber related patches
-      including 'X-Mailman-Scrubbed' header in 2.1.7.
-
-    - Fix SpamDetect.py potential hold/reject loop problem.
-
-    - A warning message from email package to the stderr can cause error
-      in Logging because stderr may be detached from the process during
-      the qrunner run.  We chose not to output errors to stderr but to
-      the logs/error if the process is running under mailmanctl subprocess.
-
-    - DKIM header cleansing was separated from Cleanse.py and added to
-      -owner messages too.
-
-    - Fixes: Lose Topics when go directly to topics URL (1194419).
-      UnicodeError running bin/arch (1395683).  edithtml.py missing import
-      (1400128).  Bad escape in cleanarch.  Wrong timezone in list archive
-      index pages (1433673).  bin/arch fails with TypeError (1430236).
-      Subscription fails with some Language combinations (1435722).
-      Postfix delayed notification not recognized (863989).  2.1.7 (VERP)
-      mistakes delay notice for bounce (1421285).  show_qfiles: 'str'
-      object has no attribute 'as_string' (1444447).
-
-  Miscellaneous
-
-    - Brad Knowles' mailman daily status report script updated to 0.0.16.
-
 2.1.7 (31-Dec-2005)
 
   Security
diff -pru mailman-cvs-2.1-maint/tests/test_bounces.py mailman-2.1.7.cg/tests/test_bounces.py
--- mailman-cvs-2.1-maint/tests/test_bounces.py	2006-03-10 11:37:01.000000000 +0100
+++ mailman-2.1.7.cg/tests/test_bounces.py	2005-08-27 03:40:17.000000000 +0200
@@ -1,4 +1,4 @@
-# Copyright (C) 2001-2006 by the Free Software Foundation, Inc.
+# Copyright (C) 2001,2002 by the Free Software Foundation, Inc.
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -12,8 +12,7 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
-# USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 
 """Test the bounce detection modules."""
 
@@ -22,8 +21,6 @@ import os
 import unittest
 import email
 
-from Mailman.Bouncers.BouncerAPI import Stop
-
 
 
 class BounceTest(unittest.TestCase):
@@ -43,24 +40,14 @@ class BounceTest(unittest.TestCase):
         ('SimpleMatch', 'simple_04.txt', ['claird@starbase.neosoft.com']),
         ('SimpleMatch', 'newmailru_01.txt', ['zzzzz@newmail.ru']),
         ('SimpleMatch', 'hotpop_01.txt', ['allensmithee@hotpop.com']),
-        ('SimpleMatch', 'microsoft_03.txt', ['midica@banknbr.com']),
-        ('SimpleMatch', 'simple_05.txt', ['rlosardo@sbcglobal.net']),
-        ('SimpleMatch', 'simple_06.txt', ['dlyle@hamiltonpacific.com']),
-        ('SimpleMatch', 'simple_07.txt', ['william.xxxx@sbcglobal.net']),
-        ('SimpleMatch', 'simple_08.txt', ['severin.XXX@t-online.de']),
-        ('SimpleMatch', 'simple_09.txt', ['RobotMail@auto-walther.de']),
-        ('SimpleMatch', 'simple_10.txt', ['sais@thehartford.com']),
-        ('SimpleMatch', 'simple_11.txt', ['carlosr73@hartfordlife.com']),
         # SimpleWarning
-        ('SimpleWarning', 'simple_03.txt', Stop),
+        ('SimpleWarning', 'simple_03.txt', ['jacobus@geo.co.za']),
         # GroupWise
         ('GroupWise', 'groupwise_01.txt', ['thoff@MAINEX1.ASU.EDU']),
         # This one really sucks 'cause it's text/html.  Just make sure it
         # doesn't throw an exception, but we won't get any meaningful
         # addresses back from it.
         ('GroupWise', 'groupwise_02.txt', []),
-        # Actually, it's from Exchange, and Exchange does recognize it
-        ('Exchange', 'groupwise_02.txt', ['omarmo@thebas.com']),
         # Yale's own
         ('Yale', 'yale_01.txt', ['thomas.dtankengine@cs.yale.edu',
                                  'thomas.dtankengine@yale.edu']),
@@ -69,14 +56,13 @@ class BounceTest(unittest.TestCase):
         ('DSN', 'dsn_02.txt', ['zzzzz@zeus.hud.ac.uk']),
         ('DSN', 'dsn_03.txt', ['ddd.kkk@advalvas.be']),
         ('DSN', 'dsn_04.txt', ['max.haas@unibas.ch']),
-        ('DSN', 'dsn_05.txt', Stop),
-        ('DSN', 'dsn_06.txt', Stop),
-        ('DSN', 'dsn_07.txt', Stop),
-        ('DSN', 'dsn_08.txt', Stop),
+        ('DSN', 'dsn_05.txt', ['pkocmid@atlas.cz']),
+        ('DSN', 'dsn_06.txt', ['hao-nghi.au@fr.thalesgroup.com']),
+        ('DSN', 'dsn_07.txt', ['david.farrar@parliament.govt.nz']),
+        ('DSN', 'dsn_08.txt', ['news-list.zope@localhost.bln.innominate.de']),
         ('DSN', 'dsn_09.txt', ['pr@allen-heath.com']),
         ('DSN', 'dsn_10.txt', ['anne.person@dom.ain']),
         ('DSN', 'dsn_11.txt', ['joem@example.com']),
-        ('DSN', 'dsn_12.txt', ['auaauqdgrdz@jtc-con.co.jp']),
         # Microsoft Exchange
         ('Exchange', 'microsoft_01.txt', ['DJBENNETT@IKON.COM']),
         ('Exchange', 'microsoft_02.txt', ['MDMOORE@BALL.COM']),
@@ -84,13 +70,8 @@ class BounceTest(unittest.TestCase):
         ('SMTP32', 'smtp32_01.txt', ['oliver@pcworld.com.ph']),
         ('SMTP32', 'smtp32_02.txt', ['lists@mail.spicynoodles.com']),
         ('SMTP32', 'smtp32_03.txt', ['borisk@gw.xraymedia.com']),
-        ('SMTP32', 'smtp32_04.txt', ['after_another@pacbell.net',
-                                     'one_bad_address@pacbell.net']),
-        ('SMTP32', 'smtp32_05.txt', ['jmrpowersports@jmrpowersports.com']),
-        ('SMTP32', 'smtp32_06.txt', ['Absolute_garbage_addr@pacbell.net']),
         # Qmail
         ('Qmail', 'qmail_01.txt', ['psadisc@wwwmail.n-h.de']),
-        ('Qmail', 'qmail_02.txt', ['rauschlo@frontfin.com']),
         # LLNL's custom Sendmail
         ('LLNL', 'llnl_01.txt', ['trotts1@llnl.gov']),
         # Netscape's server...
@@ -120,9 +101,6 @@ class BounceTest(unittest.TestCase):
                                    'yuli_kolesnikov@yahoo.com']),
         ('Yahoo', 'yahoo_09.txt', ['hankel_o_fung@yahoo.com',
                                    'ultravirus2001@yahoo.com']),
-        ('Yahoo', 'yahoo_10.txt', ['jajcchoo@yahoo.com',
-                                   'lyons94706@yahoo.com',
-                                   'turtle4jne@yahoo.com']),
         # sina.com appears to use their own weird SINAEMAIL MTA
         ('Sina', 'sina_01.txt', ['boboman76@sina.com', 'alan_t18@sina.com']),
         # No address can be detected in these...
@@ -143,12 +121,8 @@ class BounceTest(unittest.TestCase):
             # Some modules return None instead of [] for failure
             if foundaddrs is None:
                 foundaddrs = []
-            if foundaddrs is not Stop:
-                # MAS: The following strip() is only because of my
-                # hybrid test environment.  It is not otherwise needed.
-                foundaddrs = [found.strip() for found in foundaddrs]
-                addrs.sort()
-                foundaddrs.sort()
+            addrs.sort()
+            foundaddrs.sort()
             self.assertEqual(addrs, foundaddrs)
 
     def test_SMTP32_failure(self):
